/*
 *  FSPlugInObjectCocoa.h
 *  FlareStorm
 *
 *  Created by 2510 on Thu Jul 24 2003.
 *  Copyright (c) 2003-2004 by 2510. All rights reserved.
 *
 */

/* FSCoreInterfaceMessage System Specific Definitions */

enum
{
	/* result(out) type = (NSMenu * or id <NSMenuItem>) */
	FSCoreInterface_Cocoa_PlugInMenu = 0x10000,
	
	/* 子プラグインの処理 */
	/* FSCoreInterface_Cocoa_ChildrenPath に対して子プラグインのパスの配列を返し、
	   FSCoreInterface_Cocoa_ChildrenLoaded によって作成されたインスタンスを受け取る。
	   処理は配列の順序で行われ、失敗した場合には NULL が渡される。
	   Loaded には必ずしも応答する必要は無い。
	*/
	
	/* result[out] = (NSArray *) to (NSString *pathToChild) */
	FSCoreInterface_Cocoa_ChildrenPath = 0x10001,
	
	/* result[in] = (FSPlugInObject *childPlugIn) : can be NULL */
	FSCoreInterface_Cocoa_ChildrenLoaded = 0x10002,
	
	/* サブ項目の処理 */
	/* [in] プラグインマネージャの NSOutlineView と、対象となるプラグイン項目のオブジェクト。
	   [out] NSOutlineView のデータソースのデリゲートとなるオブジェクト。
	   
	   datasource には下記のメッセージがリレーされる。
	   - (void)outlineView:(NSOutlineView *)outlineView willDisplayCell:(id)cell forTableColumn:(NSTableColumn *)tableColumn item:(id)item
	   - (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item
	   - (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item
	   - (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item
	*/
	
	/* result[in] = (NSArray *) to (NSOutlineView *view, id rootItem) */
	/*      [out] = (id datasource) */
	FSCoreInterface_Cocoa_PlugInManagerSubItems = 0x10003
};

/* for FSCoreInterface_Cocoa_PlugInManagerSubItems */
#define	FSPlugInManagerTableColumnActive		"active"
#define	FSPlugInManagerTableColumnFilename		"filename"
#define	FSPlugInManagerTableColumnDescription	"description"
#define	FSPlugInManagerTableColumnConfigure		"configure"
#define	FSPlugInManagerTableColumnAbout			"about"
