/*
 *  coreservices.h
 *  FlareStorm
 *
 *  Created by 2510 on Fri May 09 2003.
 *  Copyright (c) 2003-2004 by 2510. All rights reserved.
 *
 */

/* coreservices : FlareStorm Core サービス識別子一覧 */
/*
version 2.1 (200402XX) :
 CDROM デバイスクラスを変更

version 2.0 (20040125) :
 識別子を 32bit integer から文字列へ変更
*/

#ifndef included_coreservices
#define included_coreservices

/* ######################################################################################################################################## */

/* FSCoreService - Interrupt System : 割り込み */
#define FSCoreServiceInterruptClass				"Interrupt"						// void *context

#define FSCoreServiceInterruptException			"Interrupt;Exception"			// void Exception(void *context,PSException exception)
#define FSCoreServiceInterruptInterrupt			"Interrupt;Interrupt"			// void Interrupt(void *context,PSInterrupt interrupt)
#define FSCoreServiceInterruptDMAInterrupt		"Interrupt;DMAInterrupt"		// void DMAInterrupt(void *context,PSDMA dma)

#define FSCoreServiceInterruptLockInterrupt		"Interrupt;LockInterrupt"		// void AssertInterrupt(void *context,PSInterrupt interrupt)
#define FSCoreServiceInterruptUnlockInterrupt	"Interrupt;UnlockInterrupt"		// void Interrupt(void *context,PSInterrupt interrupt)

#define FSCoreServiceInterruptGetPending		"Interrupt;GetPending"			// unsigned short GetPending(void *context)
#define FSCoreServiceInterruptGetTriggered		"Interrupt;GetTriggered"		// unsigned short GetTriggered(void *context)

#define FSCoreServiceInterruptEnableInterrupt	"Interrupt;EnableInterrupt"		// void EnableInterrupt(void *context,PSInterrupt interrupt)
#define FSCoreServiceInterruptDisableInterrupt	"Interrupt;DisableInterrupt"	// void DisableInterrupt(void *context,PSInterrupt interrupt)
#define FSCoreServiceInterruptClearInterrupt	"Interrupt;ClearInterrupt"		// void ClearInterrupt(void *context,PSInterrupt interrupt)

/* FSCoreService - Event : イベント */
/* Deliver は FSCoreExecuteFunction を使用し、正常終了時は 0、ExitRecursive 時には -1 を返す。 */
#define FSCoreServiceEventClass					"Event"				// void *context
#define FSCoreServiceEventDeliver				"Event;Deliver"		// int Deliver(void *context,unsigned long source_ident,unsigned short event_code)

/* ######################################################################################################################################## */

/* FSCoreService - CDROM : CDROM デバイス */
/* Notice: このサービスの設定、オーバーライドは禁止 */
/* First track number = 0 */
#define FSCoreServiceCDROMClass					"CDROM"						// void *context
#define FSCoreServiceCDROMRead					"CDROM;Read"				// int CDROMRead(void *context,int frame,void *buffer)
#define FSCoreServiceCDROMType					"CDROM;Type"				// int CDROMType(void *context)
#define FSCoreServiceCDROMTrackCount			"CDROM;TrackCount"			// int CDROMTrackCount(void *context)
#define FSCoreServiceCDROMTrackStart			"CDROM;TrackStart"			// int CDROMTrackStart(void *context,int track)

enum
{
	FSCoreServiceCDROMTypeCDROM = 0,
	FSCoreServiceCDROMTypeAudio = 1,
	FSCoreServiceCDROMTypePlayStation = 2,
	FSCoreServiceCDROMTypeUnknown = 3,
	
	FSCoreServiceCDROMTypeNoDisc = -1
};

/* FSCoreService - CDROM Observer : CDROM イベント・オブザーバ */
#define FSCoreServiceCDROMObserver				"CDROM;Observer"			// void *context
#define FSCoreServiceCDROMObserverShellOpen		"CDROM;Observer;ShellOpen"	// void CDROMObserverShellOpen(void *context)
#define FSCoreServiceCDROMObserverShellClose	"CDROM;Observer;ShellClose"	// void CDROMObserverShellClose(void *context)

/* FSCoreService - ISO9660 Parser : ISO9660 ファイルシステム */
#define FSCoreServiceISO9660ParserClass			"ISO9660Parser"				// void *context
#define FSCoreServiceISO9660ParserGetRoot		"ISO9660Parser;GetRoot"		// int GetRoot(void *context,int *frame)
#define FSCoreServiceISO9660ParserGetFile		"ISO9660Parser;GetFile"		// int GetFile(void *context,const char *name,int directory_frame,int *frame,int *size)
#define FSCoreServiceISO9660ParserCountFiles	"ISO9660Parser;CountFiles"	// int CountFiles(void *context,int directory_frame)
#define FSCoreServiceISO9660ParserGetName		"ISO9660Parser;GetName"		// int GetFileName(void *context,int directory_frame,int index,char *name)
#define FSCoreServiceISO9660ParserIsDirectory	"ISO9660Parser;IsDirectory"	// int IsDirectory(void *context,int directory_frame,int index)

/* FSCoreService - Boot File Parser : SYSTEM.CNF ファイルパーサ */
#define FSCoreServiceBootFileParserClass		"BootFileParser"				// void *context
#define FSCoreServiceBootFileParserGetBootFile	"BootFileParser;GetBootFile"	// int GetBootFile(void *context,char *boot_file)

/* ######################################################################################################################################## */

/* FSCoreService - Displaying : ディスプレイデバイス */
#define FSCoreServiceDisplayingClass		"Displaying"				// void *context
#define FSCoreServiceDisplayingIsFullscreen	"Displaying;IsFullScreen"	// int IsFullscreen(void *context)
#define FSCoreServiceDisplayingSetBitmap	"Displaying;SetBitmap"		// void SetBitmap(void *context,void *bitmap,int is24bit,int rowbytes)
#define FSCoreServiceDisplayingUpdateBitmap	"Displaying;UpdateBitmap"	// void UpdateBitmap(void *context)
#define FSCoreServiceDisplayingSetSize		"Displaying;SetSize"		// void SetSize(void *context,int width,int height)
#define FSCoreServiceDisplayingSetOffset	"Displaying;SetOffset"		// void SetOffset(void *context,int x,int y)

/* FSCoreService - GamePad : キー入力デバイス */
#define FSCoreServiceGamePadClass			"GamePad"			// void *context
#define FSCoreServiceGamePadGetStatus		"GamePad;GetStatus"	// unsigned short GetStatus(void *context,int pad)

/* FSCoreService - Audio Output : 音声出力デバイス */	
/* バッファフォーマット: 16-bit signed / 44.1kHz */
#define FSCoreServiceAudioOutputClass			"AudioOutput"				// void *context
#define FSCoreServiceAudioOutputBuffer			"AudioOutput;Buffer"		// void *buffer
#define FSCoreServiceAudioOutputLength			"AudioOutput;Length"		// unsigned length
#define FSCoreServiceAudioOutputStoreCursor		"AudioOutput;StoreCursor"	// unsigned StoreCursor(void *context)
#define FSCoreServiceAudioOutputPlayCursor		"AudioOutput;PlayCursor"	// unsigned PlayCursor(void *context)
#define FSCoreServiceAudioOutputSpace			"AudioOutput;Space"			// unsigned Space(void *context)
#define FSCoreServiceAudioOutputStore			"AudioOutput;Store"			// unsigned Store(void *context,unsigned bytes)
#define FSCoreServiceAudioOutputWait			"AudioOutput;Wait"			// unsigned Wait(void *context)

/* FSCoreService - CDROM Audio : CD-ROM 音声再生 */
#define FSCoreServiceCDROMAudioClass				"CDROMAudio"		// void *context
#define FSCoreServiceCDROMAudioPlay					"CDROMAudio;Play"	// void Play(void *context,void *buffer,int frames,int frequency,int stereo)
#define FSCoreServiceCDROMAudioFlush				"CDROMAudio;Flush"	// void Flush(void *context)

/* ######################################################################################################################################## */

/* FSCoreService - MemoryCard : メモリーカード */
/* Frame = 128 bytes, All Data = 128 KB */
#define FSCoreServiceMemoryCardClass			"MemoryCard"				// void *context
#define FSCoreServiceMemoryCardAvailable		"MemoryCard;Available"		// int Available(void *context,int slot)
#define FSCoreServiceMemoryCardReadFrame		"MemoryCard;ReadFrame"		// int ReadFrame(void *context,int slot,int frame,void *buffer)
#define FSCoreServiceMemoryCardWriteFrame		"MemoryCard;WriteFrame"		// void WriteFrame(void *context,int slot,int frame,const void *buffer)
#define FSCoreServiceMemoryCardAllData			"MemoryCard;AllData"		// void AllData(void *context,int slot,void *buffer)

/* FSCoreService - MemoryCardFileSystem : メモリーカード・ファイルシステム */
/* (length of file name) <= 0x7F - 0x0A */
#define FSCoreServiceMemoryCardFSClass				"MemoryCardFileSystem"					// void *class_context
#define FSCoreServiceMemoryCardFSContextForSlot		"MemoryCardFileSystem;ContextForSlot"	// void *ContextForSlot(void *class_context,int slot)
#define FSCoreServiceMemoryCardFSFlush				"MemoryCardFileSystem;Flush"			// void Flush(void *slot_context)

#define FSCoreServiceMemoryCardFSCountFiles			"MemoryCardFileSystem;CountFiles"		// int CountFiles(void *slot_context)
#define FSCoreServiceMemoryCardFSFileAtIndex		"MemoryCardFileSystem;FileAtIndex"		// int FileAtIndex(void *slot_context,int index,char *name,unsigned *size,unsigned *first_block)

#define FSCoreServiceMemoryCardFSCreateFile			"MemoryCardFileSystem;CreateFile"		// int CreateFile(void *slot_context,const char *name,unsigned size,unsigned *first_block)
#define FSCoreServiceMemoryCardFSDeleteFile			"MemoryCardFileSystem;DeleteFile"		// int DeleteFile(void *slot_context,const char *name)
#define FSCoreServiceMemoryCardFSUndeleteFile		"MemoryCardFileSystem;UndeleteFile"		// int UndeleteFile(void *slot_context,const char *name)
#define FSCoreServiceMemoryCardFSRenameFile			"MemoryCardFileSystem;RenameFile"		// int RenameFile(void *slot_context,const char *name,const char *new_name)

#define FSCoreServiceMemoryCardFSSizeOfFile			"MemoryCardFileSystem;SizeOfFile"		// int SizeOfFile(void *slot_context,unsigned first_block)
#define FSCoreServiceMemoryCardFSReadFile			"MemoryCardFileSystem;ReadFile"			// int ReadFile(void *slot_context,unsigned first_block,void *buffer)
#define FSCoreServiceMemoryCardFSReadFileFrame		"MemoryCardFileSystem;ReadFileFrame"	// int ReadFileFrame(void *slot_context,unsigned first_block,int frame,void *buffer)
#define FSCoreServiceMemoryCardFSWriteFile			"MemoryCardFileSystem;WriteFile"		// int WriteFile(void *slot_context,unsigned first_block,const void *buffer)
#define FSCoreServiceMemoryCardFSWriteFileFrame		"MemoryCardFileSystem;WriteFileFrame"	// int WriteFileFrame(void *slot_context,unsigned first_block,int frame,const void *buffer)

/* ######################################################################################################################################## */

/* FSCoreService - Logger : エミュレーションログ */	
/* 文字列のエンコーディング: UTF-8 */
#define FSCoreServiceLoggerClass				"Logger"				// void *context
#define FSCoreServiceLoggerPrint				"Logger;Print"			// void Print(void *context,const char *string)
#define FSCoreServiceLoggerLog					"Logger;Log"			// void Log(void *context,const char *string)
#define FSCoreServiceLoggerWarn					"Logger;Warn"			// void Warn(void *context,const char *string)
#define FSCoreServiceLoggerGetStatusXML			"Logger;GetStatusXML"	// const char *GetStatusXML(void *sub_context)

#define FSCoreServiceLoggerSubClass				"Logger;subclass"						// void *context
#define FSCoreServiceLoggerGetStatusDictionary	"Logger;subclass;GetStatusDictionary"	// const char *GetStatusDictionary(void *sub_context)

/* FSCoreService - PlugIn Configurator : プラグイン設定パネル */
typedef enum
{
	FSCoreServicePlugInConfigControlType_Button = 1,
	FSCoreServicePlugInConfigControlType_Radio,
	FSCoreServicePlugInConfigControlType_Checkbox,
	FSCoreServicePlugInConfigControlType_Slider
}	FSCoreServicePlugInConfigControlType;

typedef struct FSCoreServicePlugInConfigControl
{
	unsigned char							*identifier;
	int										control_id,group_id;
	
	FSCoreServicePlugInConfigControlType	type;
	unsigned char							*label; /* UTF-8 */
	double									min,max,value;
	
	void									(*callback)(void *panel,void *context,int control_id,double value);
	void									*callback_context;
}	FSCoreServicePlugInConfigControl;

#define FSCoreServicePlugInConfigClass			"Config"				// void *context
#define FSCoreServicePlugInConfigNewPanel		"Config;NewPanel"		// void NewPanel(void *context,const unsigned char *title,const char *identifier);
#define FSCoreServicePlugInConfigSetControls	"Config;SetControls"	// void SetControls(void *panel,FSCoreServicePlugInConfigControl *list,int count)
#define FSCoreServicePlugInConfigSetVisible		"Config;SetVisible"		// void SetVisible(void *panel,int visible)
#define FSCoreServicePlugInConfigDealloc		"Config;Dealloc" 		// void Dealloc(void *panel)

/* FSCoreService - Core Crash Handler : コア異常終了処理 */
#define FSCoreServiceCoreCrashHandlerClass		"CrashHandler"				// void *context
#define FSCoreServiceCoreCrashHandler			"CrashHandler;CoreCrash"	// void CoreCrash(void *context,void *freeze,unsigned length)

/* ######################################################################################################################################## */
/* # Cocoa 依存 ########################################################################################################################### */

/* FSCoreService - PlugInManagement : プラグイン・マネージャ */

#define FSCoreServicePlugInManagementClass				"Cocoa;PlugInManagement"					// void *context
#define FSCoreServicePlugInManagementPlugInSupportPath	"Cocoa;PlugInManagement;PlugInSupportPath"	// NSString *pluginSupportPath(void *context)
#define FSCoreServicePlugInManagementPlugInPath			"Cocoa;PlugInManagement;PlugInPath"			// void *plugin(void *context)

#endif